//*****************************************************************************
//!
//! @file $Id: CenteredMode.c 804 2008-02-20 09:09:20Z raubree $
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief 핔 : łPSC6PWMg`𐶐
//!
//! @todo
//! @bug
//*****************************************************************************

/*_____ ݸٰ _____________________________________________________________*/

#include "gcc_compiler.h"
#include <avr/io.h>

#include "pll_drv.h"

#include "psc_drv.h"

//_____ ` __________________________________________________________________

//#define T_OVERLAP			/* T_OVERLAP : dl̐ݒI */

#ifdef T_OVERLAP

#define A_SA_VAL	40
#define A_RA_VAL	75
#define A_SB_VAL	25

#define B_SA_VAL	115
#define B_RA_VAL	80
#define B_SB_VAL	110

#define C_SA_VAL	90
#define C_RA_VAL	80
#define C_SB_VAL	60

#define RB_VAL		125

#else

#define A_SA_VAL	25
#define A_RA_VAL	75
#define A_SB_VAL	40

#define B_SA_VAL	110
#define B_RA_VAL	80
#define B_SB_VAL	115

#define C_SA_VAL	60
#define C_RA_VAL	80
#define C_SB_VAL	90

#define RB_VAL		125

#endif

/* Ȃg̉pɒ`ĂB */
#define PSC_PRESCALER			PSC_NODIV_CLOCK
#define PSC_CLOCK_SOURCE		PSC_CLOCK_SOURCE_EQ_CLKIO

#define PSC_MODE				PSC_MODE_CENTERED

#define PSC_OUTPUT_B_POLARITY	PSC_OUTPUT_HIGH
//#define PSC_OUTPUT_B_POLARITY	PSC_OUTPUT_LOW
#define PSC_OUTPUT_A_POLARITY	PSC_OUTPUT_HIGH
//#define PSC_OUTPUT_A_POLARITY	PSC_OUTPUT_LOW

/*F**************************************************************************
* NAME: PSC
*****************************************************************************/
void PSC_Init (void)
{
  Psc_enable_all_outputs();							// PSCSo͋

  Psc_set_module_A(A_SA_VAL,A_RA_VAL,A_SB_VAL);		// PSC0rl
  Psc_set_module_B(B_SA_VAL,B_RA_VAL,B_SB_VAL);		// PSC1rl
  Psc_set_module_C(C_SA_VAL,C_RA_VAL,C_SB_VAL);		// PSC2rl
  Psc_set_register_RB(RB_VAL);						// ʔrl

  Psc_config();										// PSC`Ԑݒ

  Psc_run();										// PSCs
}

/*F**************************************************************************
* NAME: main
*****************************************************************************/
int main (void)
{
  Start_pll_64_mega();		// PLL 64MHzn
  Wait_pll_ready();			// PLLҋ@
  PSC_Init();				// PSC

  while(1) {;}
}
