/*C****************************************************************************
* $RCSfile: test_int_PSC2.c,v $
*------------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*------------------------------------------------------------------------------
* J:			$Name: ballast-valid-si-1_0_0 $
* :			$Revision: 1.1 $
* ̧CVSID:	$Id: test_int_PSC2.c,v 1.1 2004/10/01 12:24:56 raubree Exp $
*------------------------------------------------------------------------------
* ړI:
* ̧قPSCg`𐶐۸т񋟂܂B
******************************************************************************/

/*_____ ݸٰ _____________________________________________________________*/
#include "lib_mcu/compiler.h"
#include "lib_mcu/mcu.h"
#include "lib_mcu/pll.h"

#define DEAD_TIME_0		100
#define ON_TIME_0		2400
#define DEAD_TIME_1		200
#define ON_TIME_1		1300

  unsigned char Fault = 0;
  unsigned char Ent = 0;

  /* ċN荞݂IɂSW1ĂB */
  /* ̍Ōł̊荞݂IɂSW2ĂB */

  /* PEͽɐڑ܂B */
  /* PDLEDɐڑ܂B */

  /* : PE1͸ۯ͂łB */
  /*	 STK500XTAL1ެ߂苎邱ƂYȂłB */

/*F****************************************************************************
* NAME: PSC2荞
******************************************************************************/
#pragma vector = (PSC2_CAPT_vect)
__interrupt void PSC2_Capture_IT(void)
{
//  PIFR1 = (1<<PEV1B);
  PIFR2 = 0x1F;					// PSC֌W荞ݗv׸މ
  Ent++;						// 荞݌vis
  Ent = Ent & 0xF;				// Kۂ
  PORTD = ~((Ent<<4)|Fault);	// LED\
}

#pragma vector = (PSC2EC_vect)
__interrupt void PSC2_End_Cycle_IT(void)
{
  PIFR2 = 0x1F;					// PSC֌W荞ݗv׸މ
  Ent++;						// 荞݌vis
  Ent = Ent & 0xF;				// Kۂ
  PORTD = ~((Ent<<4)|Fault);	// LED\
}

/*F****************************************************************************
* NAME: PSC2
******************************************************************************/
void PSC2_Init (void)
{
  PSOC2 = (1<<POEN2A)|(1<<POEN2B);
  OCR2SAH = HIGH(DEAD_TIME_0);
  OCR2SAL = LOW(DEAD_TIME_0);
  OCR2RAH = HIGH(ON_TIME_0);
  OCR2RAL = LOW(ON_TIME_0);
  OCR2SBH = HIGH(DEAD_TIME_1);
  OCR2SBL = LOW(DEAD_TIME_1);
  OCR2RBH = HIGH(ON_TIME_1);
  OCR2RBL = LOW(ON_TIME_1);
  PCNF2 = (1<<PMODE21)|(0<<PMODE20)|(1<<POP2);		/* 4XΓ */
  PFRC2A = (1<<PCAPE2A)|(0<<PISEL2A)|(1<<PELEV2A)|(1<<PRFM2A3);
  PFRC2B = 0;
  PCTL2 = (1<<PRUN2);								/* s !! */
}

/*F**************************************************************************
* NAME: main
*****************************************************************************/
int main (void)
{
// OSCCAL=110;
  start_PLL_64();							// PLL 64MHzn
  wait_PLL();								// PLLҋ@
  PSC2_Init();								// PSC2
// PIM2 = (1<<PEVE2A);
  PIM2 = (0<<PEOPE2);						// PSCI荞݋֎~
  Enable_interrupt();						// S̊荞݋
// DDRE = (1<<DDE2);

  PORTD = 0xFF;								// SLED
  DDRD = 0xFB;								// PD2ȊOo͐ݒ
  while(1)
  {
	if (bit_is_clear(PINE,PINE1))			// PE1(SW1)=LŁA
	{
	  while (bit_is_clear(PINE,PINE1));		// PE1(SW1)Jҋ@
	  PIM2 = (1<<PEVE2A);					/* Oۊ荞݂̂݋ */
	}
	if (bit_is_clear(PINE,PINE2))			// PE2(SW2)=LŁA
	{
	  while (bit_is_clear(PINE,PINE2));		// PE2(SW2)Jҋ@
	  PIM2 = (1<<PEOPE2);					/* PSC2I荞݂̂݋ */
	}
  }
}
